/// <reference types="react" />
import { IObservable } from 'mobx';
export interface ICansModel {
    namespace: string;
    protected?: boolean;
    observable?: any;
    actions?: {
        [name: string]: (app: Cans) => () => void;
    } | {
        [name: string]: () => void;
    };
    state?: {
        [name: string]: any;
    };
    computed?: {
        [name: string]: () => any;
    };
}
export interface ICansModelObject {
    [namespace: string]: IObservable;
}
export interface ICansPluginObject {
    [namespace: string]: any;
}
export interface ICansPlugin {
    (app: Cans, options: any): void;
}
export declare class Cans {
    private __routerComponent;
    private __mountedRoot?;
    private __models;
    private __modelsObject;
    private __getInjectList();
    readonly models: {};
    route(routeFunc: () => JSX.Element): void;
    model(model: ICansModel): void;
    start(el?: Element | null): void;
    use(plugin: ICansPlugin, options?: any): void;
}
export interface ICansOptions {
    useStrict?: boolean;
}
declare const createCansApp: (options?: ICansOptions) => Cans;
export declare const inject: (view: any) => any;
export default createCansApp;
